' Bestimmung der Lagerichtung: Auswertung eines BIAS-Punktes
' an einer Linie

DEFDBL a-z

INPUT "Startpunkt der Linie";xp1,yp1
INPUT "Endpunkt der Linie";xp2,yp2
INPUT "BIAS-Punkt";xb,yb
PruefeLagerichtung xp1,yp1,xp2,yp2,xb,yb,Ri%
LINE (xp1,yp1)-(xp2,yp2)
LINE (xb-4,yb)-(xb+4,yb),2
LINE (xb,yb-2)-(xb,yb+2),2
IF Ri%=1 THEN
  PRINT "Der BIAS-Punkt zeigt in die positive Richtung, d.h. bei einem"
  PRINT "auf den Endpunkt gerichteteten Blick vom Startpunkt aus befindet er"
  PRINT "sich auf der linken Seite."
ELSEIF Ri%=-1 THEN
  PRINT "Der BIAS-Punkt zeigt in die negative Richtung, d.h. bei einem"
  PRINT "auf den Endpunkt gerichteteten Blick vom Startpunkt aus befindet er"
  PRINT "sich auf der rechten Seite."
ELSE
  PRINT "Der BIAS-Punkt liegt genau auf der Geraden, weise somit keine"
  PRINT "eindeutige Richtung auf."
END IF

SUB PruefeLagerichtung (x1,y1,x2,y2,xl,yl,r%) STATIC
  dx=x2-x1:dy=y2-y1
  l=SQR(dx*dx+dy*dy)
  r%=SGN((yl-y1)*dx/l-(xl-x1)*dy/l)
END SUB
