' Dieses Programm erzeugt eine verzerrte Kopie einer Liniengeometrie
' (Allgemeine parallel affine Abbildung) (Abbildung, bei der parallele
' Linien weiterhin parallel sind und ausserdem proportional zur
' urspruenglichen Geometrie)

DEFDBL a-z
DIM SHARED i%(5),z%(5),ZwDe(5)

DIM x1(10),y1(10),x2(10),y2(10),xq(2),yq(2),xz(2),yz(2)
FOR i%=0 TO 10
  WHILE MOUSE(0)>-.5
  WEND
  x1(i%)=MOUSE(1)
  y1(i%)=MOUSE(2)
  WHILE MOUSE(0)<-.5
  WEND
  PSET (x1(i%),y1(i%)),1
  WHILE MOUSE(0)>-.5
  WEND
  x2(i%)=MOUSE(1)
  y2(i%)=MOUSE(2)
  WHILE MOUSE(0)<-.5
  WEND
  LINE (x1(i%),y1(i%))-(x2(i%),y2(i%)),1
NEXT i%
PRINT "Bitte drei Bezugspunkte am Quellobjekt angeben"
FOR i%=0 TO 2
  WHILE MOUSE(0)>-.5
  WEND
  xq(i%)=MOUSE(1)
  yq(i%)=MOUSE(2)
  WHILE MOUSE(0)<-.5
  WEND
  LINE (xq(i%)-4,yq(i%))-(xq(i%)+4,yq(i%)),3
  LINE (xq(i%),yq(i%)-2)-(xq(i%),yq(i%)+2),3
NEXT i%
PRINT "Bitte diese drei Punkte am Zielort angeben"
FOR i%=0 TO 2
  WHILE MOUSE(0)>-.5
  WEND
  xz(i%)=MOUSE(1)
  yz(i%)=MOUSE(2)
  WHILE MOUSE(0)<-.5
  WEND
  LINE (xz(i%)-4,yz(i%))-(xz(i%)+4,yz(i%)),3
  LINE (xz(i%),yz(i%)-2)-(xz(i%),yz(i%)+2),3
NEXT i%

DIM SHARED basx,basy,strxx,strxy,stryx,stryy
DIM Ko(2,2),xu(2),ru(2)
FOR i%=0 TO 2
  Ko(0,i%)=xq(i%)
  Ko(1,i%)=yq(i%)
  Ko(2,i%)=1#
  ru(i%)=xz(i%)
NEXT i%
LoeseLineareGleichungAuf Ko(),ru(),xu(),Fe%
IF Fe% THEN
  PRINT "Keine Umwandlung mglich!"
END IF
strxx=xu(0)
strxy=xu(1)
basx=xu(2)
FOR i%=0 TO 2
  Ko(0,i%)=xq(i%)
  Ko(1,i%)=yq(i%)
  Ko(2,i%)=1#
  ru(i%)=yz(i%)
NEXT i%
LoeseLineareGleichungAuf Ko(),ru(),xu(),Fe%
IF Fe% THEN
  PRINT "Keine Umwandlung mglich!"
END IF
stryx=xu(0)
stryy=xu(1)
basy=xu(2)
FOR i%=0 TO 10
  BesNeupkt x1(i%),y1(i%),x1,y1
  BesNeupkt x2(i%),y2(i%),x2,y2
  LINE (x1,y1)-(x2,y2),2
NEXT i%
' Suche des Punktes, der noch identisch ist
ERASE Ko
DIM Ko(1,1)
Ko(0,0)=strxx-1#
Ko(1,0)=strxy
ru(0)=-basx
Ko(0,1)=stryx
Ko(1,1)=stryy-1#
ru(1)=-basy
LoeseLineareGleichungAuf Ko(),ru(),xu(),Fe%
IF Fe% THEN
  PRINT "Affinittsgerade vorhanden oder gar kein identischer Punkt!"
  STOP
END IF
LINE (xu(0)-5#,xu(1))-STEP(10,0),3
LINE STEP(-5,5)-STEP(0,-10),3

SUB BesNeupkt (xq,yq,xz,yz) STATIC
  xz=basx+xq*strxx+yq*strxy
  yz=basy+xq*stryx+yq*stryy
END SUB
  
SUB LoeseLineareGleichungAuf (an(),rn(),xn(),f%)STATIC
  BestimmeDeterminante an(),De
  f%=De=0#
  IF NOT f% THEN
    n%=UBOUND(an,1)
    FOR i%=0 TO n%
      FOR j%=0 TO n%
        SWAP an(i%,j%),rn(j%)
      NEXT j%
      BestimmeDeterminante an(),xn(i%)
      xn(i%)=xn(i%)/De
      FOR j%=0 TO n%
        SWAP an(i%,j%),rn(j%)
      NEXT j%
    NEXT i%
  END IF
END SUB

SUB BestimmeDeterminante (Matr(),Det) STATIC
  n%=UBOUND(Matr,1)
  FOR i%=0 TO 5
    z%(i%)=i%
  NEXT i%
  vn%=0
  e%=0
  Ebenenbeginn:
  i%(e%)=e%
  ZwDe(e%)=0#
  NaechstDurchg:
  IF i%(e%)=n%+1 THEN EndeSchleife
  IF i%(e%)<>e% THEN
    SWAP z%(e%),z%(i%(e%))
    vn%=NOT vn%
  END IF
  e%=e%+1
  IF e%<n% THEN Ebenenbeginn
  IF vn% THEN
    ZwDe(e%)=-Matr(e%,z%(e%))
  ELSE
    ZwDe(e%)=Matr(e%,z%(e%))
  END IF
  EbeneSchliessen:
  e%=e%-1
  ZwDe(e%)=ZwDe(e%)+Matr(e%,z%(e%))*ZwDe(e%+1)
  IF i%(e%)<>e% THEN
    SWAP z%(e%),z%(i%(e%))
    vn%=NOT vn%
  END IF
  i%(e%)=i%(e%)+1
  GOTO NaechstDurchg
  EndeSchleife:
  IF e% THEN EbeneSchliessen
  Det=ZwDe(0)
END SUB
