' Kreisbogenkonstruktion-Spezialprobleme: Kreisbogen, definiert durch
' Bogenlaenge, tangential zu zwei gegebenen Linien

DEFDBL a-z
DIM mx(7),my(7),kr(7),sw(7),ew(7)
DIM SHARED Pi
Pi=4#*ATN(1#)

PRINT "Erste Linie"
INPUT "Startpunkt";x11,y11
INPUT "Endpunkt";x12,y12
PRINT "Zweite Linie"
INPUT "Startpunkt";x21,y21
INPUT "Endpunkt";x22,y22

INPUT "Bogenlnge";b

aL%=0

BestimmePolarwinkel x11,y11,x12,y12,w1
BestimmePolarwinkel x21,y21,x22,y22,w2
w=w2-w1

wl=w
f1%=0:f2%=-1
GOSUB LoesungspaarBilden
IF w>Pi THEN
  wl=w-3#*Pi
ELSE
  wl=w+Pi
END IF
f1%=-1:f2%=-1
GOSUB LoesungspaarBilden
IF w>-Pi THEN
  wl=w-Pi
ELSE
  wl=w+3#*Pi
END IF
f1%=-1:f2%=0
GOSUB LoesungspaarBilden
IF w>0# THEN
  wl=w-2#*Pi
ELSE
  wl=w+2#*Pi
END IF
f1%=0:f2%=0
GOSUB LoesungspaarBilden

PRINT "Total";aL%;"Lsungen gefunden:"
FOR i%=0 TO aL%-1
  PRINT "x=";mx(i%);"  y=";my(i%);"  r=";kr(i%)
  PRINT "sw=";sw(i%)*180#/Pi#;"  ew=";ew(i%)*180#/Pi;"";" K:";
  h=ew(i%)-sw(i%)
  IF h<0# THEN
    h=h+2#*Pi
  END IF
  PRINT h*kr(i%)
NEXT i%

LINE (x11,187#-y11)-(x12,187#-y12)
LINE (x21,187#-y21)-(x22,187#-y22)
FOR i%=0 TO aL%-1
  CIRCLE (mx(i%),187#-my(i%)),kr(i%),3,sw(i%),ew(i%),1!
NEXT i%

END

LoesungspaarBilden:
IF wl<>0# THEN
  r=b/wl
  IF f1% THEN
    VerschiebeParallel x11,y11,x12,y12,r,xh11,yh11,xh12,yh12
    VerschiebeParallel x22,y22,x21,y21,r,xh21,yh21,xh22,yh22
    BestimmeSchnittpunktLinieLinie xh11,yh11,xh12,yh12,xh21,yh21,xh22,yh22,mx(aL%),my(aL%),f%
    VerschiebeParallel x12,y12,x11,y11,r,xh11,yh11,xh12,yh12
    VerschiebeParallel x21,y21,x22,y22,r,xh21,yh21,xh22,yh22
    BestimmeSchnittpunktLinieLinie xh11,yh11,xh12,yh12,xh21,yh21,xh22,yh22,mx(aL%+1),my(aL%+1),f%
  ELSE
    VerschiebeParallel x11,y11,x12,y12,r,xh11,yh11,xh12,yh12
    VerschiebeParallel x21,y21,x22,y22,r,xh21,yh21,xh22,yh22
    BestimmeSchnittpunktLinieLinie xh11,yh11,xh12,yh12,xh21,yh21,xh22,yh22,mx(aL%),my(aL%),f%
    VerschiebeParallel x12,y12,x11,y11,r,xh11,yh11,xh12,yh12
    VerschiebeParallel x22,y22,x21,y21,r,xh21,yh21,xh22,yh22
    BestimmeSchnittpunktLinieLinie xh11,yh11,xh12,yh12,xh21,yh21,xh22,yh22,mx(aL%+1),my(aL%+1),f%
  END IF
  IF NOT f% THEN
    kr(aL%)=ABS(r)
    kr(aL%+1)=ABS(r)
    f3%=wl>0#
    IF w1<1.5#*Pi THEN
      sw(aL%)=w1+Pi/2#
    ELSE
      sw(aL%)=w1-1.5#*Pi
    END IF
    IF w2<Pi/2# THEN
      ew(aL%)=w2+1.5#*Pi
    ELSE
      ew(aL%)=w2-Pi/2#
    END IF
    IF w1<Pi/2# THEN
      sw(aL%+1)=w1+1.5#*Pi
    ELSE
      sw(aL%+1)=w1-Pi/2#
    END IF
    IF w2<1.5#*Pi THEN
      ew(aL%+1)=w2+Pi/2#
    ELSE
      ew(aL%+1)=w2-1.5#*Pi
    END IF
    IF f3% THEN
      SWAP sw(aL%),sw(aL%+1)
    END IF
    IF f1% EQV f3% THEN
      SWAP ew(aL%),ew(aL%+1)
    END IF
    IF NOT f3% THEN
      SWAP sw(aL%),ew(aL%)
      SWAP sw(aL%+1),ew(aL%+1)
    END IF
    aL%=aL%+2
  END IF
END IF
RETURN

SUB VerschiebeParallel (x1,y1,x2,y2,a,xp1,yp1,xp2,yp2) STATIC
  dx=x2-x1
  dy=y2-y1
  a1=SQR(dx*dx+dy*dy)
  w1=dy*a/a1
  w2=dx*a/a1
  xp1=x1-w1
  yp1=y1+w2
  xp2=x2-w1
  yp2=y2+w2
END SUB

SUB BestimmeSchnittpunktLinieLinie (x1,y1,x2,y2,x3,y3,x4,y4,xs,ys,f%) STATIC
  IF x1=x2 THEN
    xh1=x1:yh1=y1
    xh2=x3:yh2=y3
    dx1=0#:dy1=y2-y1
    dx2=x4-x3:dy2=y4-y3
  ELSE
    xh1=x3:yh1=y3
    xh2=x1:yh2=y1
    dx1=x4-x3:dy1=y4-y3
    dx2=x2-x1:dy2=y2-y1
  END IF
  IF dx1=0# THEN
    f%=dx2=0#
    IF NOT f% THEN
      xs=xh1
      ys=yh2+(xs-xh2)*dy2/dx2
    END IF
  ELSE
    s1=dy1/dx1
    s2=dy2/dx2
    f%=ABS(s1-s2)<=(1#+s1*s2)*RuFe
    IF NOT f% THEN
      yh3=yh1-s1*xh1
      yh4=yh2-s2*xh2
      xs=(yh4-yh3)/(s1-s2)
      ys=yh3+s1*xs
    END IF
  END IF
END SUB

SUB BestimmeSchnittpunktLinieKreis (x1,y1,x2,y2,x,y,r2,xs1,ys1,xs2,ys2,f%) STATIC
  BestimmeLinieLotfusspunkt x1,y1,x2,y2,x,y,xl,yl
  dx=xl-x
  dy=yl-y
  a2=dx*dx+dy*dy
  f%=a2>r2
  IF ABS(r2-a2)<=2#*LTol*SQR(r2) THEN
    f%=1
    xs1=xl
    ys1=yl
  ELSEIF NOT f% THEN
    b=SQR(r2-a2)
    dx=x2-x1
    dy=y2-y1
    a2=dx*dx+dy*dy
    a=SQR(a2)
    xb=b*dx/a
    yb=b*dy/a
    xs1=xl+xb
    ys1=yl+yb
    xs2=xl-xb
    ys2=yl-yb
  END IF
END SUB

SUB BestimmeSchnittpunktKreisKreis (x1,y1,r12,x2,y2,r22,xs1,ys1,xs2,ys2,f%) STATIC
  dx=x2-x1
  dy=y2-y1
  a2=dx*dx+dy*dy
  f%=a2<=LTol2
  IF NOT f% THEN
    a=SQR(a2)
    y=(a2+r12-r22)/2#/a
    xk=dx/a
    yk=dy/a
    xh=x1+xk*y
    yh=y1+yk*y
    b2=r12-y*y
    f%=b2<0#
    IF ABS(b2)<=2#*r1*RuFe THEN
      xs1=xh
      ys1=yh
      f%=1
    ELSEIF NOT f% THEN
      b=SQR(b2)
      xl=xk*b
      yl=yk*b
      xs1=xh-yl
      ys1=yh+xl
      xs2=xh+yl
      ys2=yh-xl
    END IF
  END IF
END SUB

SUB BestimmeLinieLotfusspunkt(x1,y1,x2,y2,xp,yp,xl,yl) STATIC
  dx=x2-x1
  dy=y2-y1
  IF dx=0# THEN
    xl=x1
    yl=yp
  ELSEIF dy=0# THEN
    xl=xp
    yl=y1
  ELSE
    S=dy/dx
    p=-dx/dy
    xl=(y1-x1*S-yp+xp*p)/(p-S)
    yl=(x1+y1*p-xp-yp*S)/(p-S)
  END IF
END SUB

SUB PruefeRealImaginaerLinie (x1,y1,x2,y2,x,y,t%) STATIC
  IF ABS(x2-x1)>ABS(y2-y1) THEN
    IF x2>x1 THEN
      t%=x>=x1-LTol AND x<=x2+LTol
    ELSE
      t%=x>=x2-LTol AND x<=x1+LTol
    END IF
  ELSE
    IF y2>y1 THEN
      t%=y>=y1-LTol AND y<=y2+LTol
    ELSE
      t%=y>=y2-LTol AND y<=y1+LTol
    END IF
  END IF
END SUB

SUB PruefeRealImaginaerBogen (xm,ym,r,sw,ew,x,y,t%) STATIC
  BestimmePolarwinkel xm,ym,x,y,w
  h=LTol/r
  IF ew>sw THEN
    t%=w>sw-h AND w<ew+h
  ELSE
    t%=w>sw-h OR w<ew+h
  END IF
END SUB

SUB BestimmePolarwinkel (xm,ym,x,y,w) STATIC
  dx=x-xm
  dy=y-ym
  IF dx=0# THEN 
    IF dy<0# THEN
      w=1.5#*Pi
    ELSE
      w=Pi/2#
    END IF
  ELSE
    IF dx<0# THEN
      h=1#
    ELSE
      IF dy<0# THEN
        h=2#
      ELSE
        h=0#
      END IF
    END IF
    w=ATN(dy/dx)+Pi*h
  END IF
  TROFF
END SUB
