' Bestimmung aller tangentialen Kreise an 3 gegebene Kreise (Problem des
' Appolonius)

DEFDBL a-z

DIM mx(7),my(7),kr(7)

PRINT "Erster Kreis"
INPUT "Mittelpunkt";xm1,ym1
INPUT "Radius";r1
PRINT "Zweiter Kreis"
INPUT "Mittelpunkt";xm2,ym2
INPUT "Radius";r2
PRINT "Dritter Kreis"
INPUT "Mittelpunkt";xm3,ym3
INPUT "Radius";r3

aL%=0
IF r2>r1 THEN
  SWAP xm1,xm2:SWAP ym1,ym2:SWAP r1,r2
END IF
IF r3>r2 THEN
  SWAP xm3,xm2:SWAP ym3,ym2:SWAP r3,r2
END IF
IF r3>r1 THEN
  SWAP xm1,xm3:SWAP ym1,ym3:SWAP r1,r3
END IF
r12=r1*r1:r22=r2*r2:r32=r3*r3
dy12=ym1-ym2:dy23=ym2-ym3:dy31=ym3-ym1
q=2#*(xm1*dy23+xm2*dy31+xm3*dy12)
IF q=0# THEN
  dx12=xm1-xm2:dx23=xm2-xm3:dx31=xm3-xm1
  h1=dx23*dx23+dy23*dy23:h2=dx31*dx31+dy31*dy31:h3=dx12*dx12+dy12*dy12
  dx=dx23:dy=dy23:h=h1
  IF h2>h THEN
    dx=dx31:dy=dy31:h=h2
  END IF
  IF h3>h THEN
    dx=dx12:dy=dy12:h=h3
  END IF
  IF h<>0# THEN
    h=SQR(h)
    nvx=dx/h
    nvy=dy/h
    xt1=xm1*nvx+ym1*nvy
    xt2=xm2*nvx+ym2*nvy
    xt3=xm3*nvx+ym3*nvy
    yt=ym1*nvx-xm1*nvy
    xt12=xt1*xt1:xt22=xt2*xt2:xt32=xt3*xt3
    FOR i%=1 TO 2
      FOR j%=1 TO 2
        dx=xt2-xt1:dr=r2-r1:dr2=dr*dr:h=xt12-xt22+dr2
        a12=4#*(dx*dx-dr2)
        b12=4#*dx*h+8#*dr2*xt1
        c12=h*h-4#*dr2*xt12
        q12=2#*dr:q122=q12*q12
        dx=xt3-xt2:dr=r3-r2:dr2=dr*dr:h=xt22-xt32+dr2
        a23=4#*(dx*dx-dr2)
        b23=4#*dx*h+8#*dr2*xt2
        c23=h*h-4#*dr2*xt22
        q23=2#*dr:q232=q23*q23
        dx=xt1-xt3:dr=r1-r3:dr2=dr*dr:h=xt32-xt12+dr2
        a31=4#*(dx*dx-dr2)
        b31=4#*dx*h+8#*dr2*xt3
        c31=h*h-4#*dr2*xt32
        q31=2#*dr:q312=q31*q31
        a123=a12*q232-a23*q122
        b123=b12*q232-b23*q122
        c123=c12*q232-c23*q122
        a231=a23*q312-a31*q232
        b231=b23*q312-b31*q232
        c231=c23*q312-c31*q232
        a312=a31*q122-a12*q312
        b312=b31*q122-b12*q312
        c312=c31*q122-c12*q312
        m=b123*a231-b231*a123
        q=c123*a231-c231*a123
        IF m=0# THEN
          m=b231*a312-b312*a231
          q=c231*a312-c312*a231
          IF m=0# THEN
            m=b312*a123-b123*a312
            q=c312*a123-c123*a312
          END IF
        END IF
        IF m<>0# THEN
          x=-q/m
          f%=0
          IF q12<>0# THEN
            h=x*(a12*x+b12)+c12
            IF h<0# THEN
              f%=-1
            ELSE
              yh=SQR(h)/q12
            END IF
          ELSE
            f%=-1
          END IF
          IF f% THEN
            IF q23<>0# THEN
              h=x*(a23*x+b23)+c23
              f%=h<0#
              IF NOT f% THEN
                yh=SQR(h)/q23
              END IF
            ELSE
              f%=-1
            END IF
          END IF
          IF f% THEN
            IF q31<>0# THEN
              h=x*(a31*x+b31)+c31
              f%=h<0#
              IF NOT f% THEN
                yh=SQR(h)/q31
              END IF
            ELSE
              f%=-1
            END IF
          END IF
          IF NOT f% THEN
            y1=yt+yh
            y2=yt-yh
            dx1=x-xt1
            f%=0
            IF r1<>r3 THEN
              dx2=x-xt3
              kr(aL%)=ABS((dx1*dx1-dx2*dx2-r12+r32)/2#/(r1-r3))
            ELSEIF r1<>r2 THEN
              dx2=x-xt2
              kr(aL%)=ABS((dx1*dx1-dx2*dx2-r12+r22)/2#/(r1-r2))
            ELSE
              f%=-1
            END IF
            IF NOT f% THEN
              mx(aL%)=x*nvx-y1*nvy
              my(aL%)=y1*nvx+x*nvy
              mx(aL%+1)=x*nvx-y2*nvy
              my(aL%+1)=y2*nvx+x*nvy
              kr(aL%+1)=kr(aL%)
              aL%=aL%+2
            END IF
          END IF
        END IF  
        r2=-r2
      NEXT j%
      r1=-r1
    NEXT i%
  END IF
ELSE
  h1=xm1*xm1+ym1*ym1-r12
  h2=xm2*xm2+ym2*ym2-r22
  h3=xm3*xm3+ym3*ym3-r32
  xp=(h1*dy23+h2*dy31+h3*dy12)/q
  yp=(h1*(xm3-xm2)+h2*(xm1-xm3)+h3*(xm2-xm1))/q
  Fe12%=r12=r22
  IF NOT Fe12% THEN
    xa12=(r1*xm2-r2*xm1)/(r1-r2)
    ya12=(r1*ym2-r2*ym1)/(r1-r2)
  END IF
  IF r1=0# AND Fe12% THEN
    xi12=(xm1+xm2)/2#
    yi12=(ym1+ym2)/2#
  ELSE
    xi12=(r1*xm2+r2*xm1)/(r1+r2)
    yi12=(r1*ym2+r2*ym1)/(r1+r2)
  END IF
  Fe23%=r22=r32
  IF NOT Fe23% THEN
    xa23=(r2*xm3-r3*xm2)/(r2-r3)
    ya23=(r2*ym3-r3*ym2)/(r2-r3)
  END IF
  IF r2=0# AND Fe23% THEN
    xi23=(xm2+xm3)/2#
    yi23=(xm2+xm3)/2#
  ELSE
    xi23=(r2*xm3+r3*xm2)/(r2+r3)
    yi23=(r2*ym3+r3*ym2)/(r2+r3)
  END IF
  Fe31%=r32=r12
  IF NOT Fe31% THEN
    xa31=(r3*xm1-r1*xm3)/(r3-r1)
    ya31=(r3*ym1-r1*ym3)/(r3-r1)
  END IF
  IF r3=0# AND Fe31% THEN
    xi31=(xm3+xm1)/2#
    yi31=(ym3+ym1)/2#
  ELSE
    xi31=(r3*xm1+r1*xm3)/(r3+r1)
    yi31=(r3*ym1+r1*ym3)/(r3+r1)
  END IF
  Fa%=1
  xa1=xi12:ya1=yi12
  IF Fe23% THEN
    xa2=xi31:ya2=yi31
  ELSE
    xa2=xa23:ya2=ya23
  END IF
  GOSUB LoesungspaarGenerieren
  Fa%=2
  xa1=xi12:ya1=yi12
  IF Fe31% THEN
    xa2=xi23:ya2=yi23
  ELSE
    xa2=xa31:ya2=ya31
  END IF
  GOSUB LoesungspaarGenerieren
  Fa%=3
  xa1=xi31:ya1=yi31
  IF Fe12% THEN
    xa2=xi23:ya2=yi23
  ELSE
    xa2=xa12:ya2=ya12
  END IF
  GOSUB LoesungspaarGenerieren
  Fa%=4
  IF Fe12% AND Fe23% AND Fe31% THEN
    dx=xp-xm1:dy=yp-ym1
    hr=SQR(dx*dx+dy*dy)
    mx(aL%)=xp
    my(aL%)=yp
    kr(aL%)=hr-r1
    mx(aL%+1)=xp
    my(aL%+1)=yp
    kr(aL%+1)=hr+r1
    aL%=aL%+2
  ELSEIF Fe12% THEN
    xa1=xa23:ya1=ya23
    xa2=xa31:ya2=ya31
    GOSUB LoesungspaarGenerieren
  ELSEIF Fe23% THEN
    xa1=xa31:ya1=ya31
    xa2=xa12:ya2=ya12
    GOSUB LoesungspaarGenerieren
  ELSE
    xa1=xa12:ya1=ya12
    xa2=xa23:ya2=ya23
    GOSUB LoesungspaarGenerieren
  END IF
END IF

PRINT "Total";aL%;"Mglichkeiten:"
FOR i%=0 TO aL%-1
  PRINT "x=";mx(i%);"  y=";my(i%);"  r=";kr(i%)
  PRINT "R.fe.:";
  dx=mx(i%)-xm1:dy=my(i%)-ym1
  a=SQR(dx*dx+dy*dy)
  f1=ABS(a+r1-kr(i%))
  f2=ABS(a-r1-kr(i%))
  IF f1<f2 THEN
    f=f1
  ELSE
    f=f2
  END IF
  PRINT f;
  dx=mx(i%)-xm2:dy=my(i%)-ym2
  a=SQR(dx*dx+dy*dy)
  f1=ABS(a+r2-kr(i%))
  f2=ABS(a-r2-kr(i%))
  IF f1<f2 THEN
    f=f1
  ELSE
    f=f2
  END IF
  PRINT f;
  dx=mx(i%)-xm3:dy=my(i%)-ym3
  a=SQR(dx*dx+dy*dy)
  f1=ABS(a+r3-kr(i%))
  f2=ABS(a-r3-kr(i%))
  IF f1<f2 THEN
    f=f1
  ELSE
    f=f2
  END IF
  PRINT f
NEXT i%

CIRCLE (xm1,ym1),r1,1,,,1!
CIRCLE (xm2,ym2),r2,1,,,1!
CIRCLE (xm3,ym3),r3,1,,,1!

FOR i%=0 TO aL%-1
  CIRCLE (mx(i%),my(i%)),ABS(kr(i%)),3,,,1!
NEXT i%

END

LoesungspaarGenerieren:
xm=xm1:ym=ym1:rq=r12
GOSUB PolpunktBerechnen
IF f% THEN
  xb11=xm1
  yb11=ym1
  xb12=xm1
  yb12=ym1
  f%=0
ELSE
  BestimmeSchnittpunktLinieKreis xp,yp,xPol,yPol,xm1,ym1,r12,xb11,yb11,xb12,yb12,f%
  IF f%=1 THEN
    xb12=xb11:yb12=yb11:f%=0
  END IF
END IF
IF f% THEN RETURN
xm=xm2:ym=ym2:rq=r22
GOSUB PolpunktBerechnen
IF f% THEN
  xb21=xm2
  yb21=ym2
  xb22=xm2
  yb22=ym2
  f%=0
ELSE
  BestimmeSchnittpunktLinieKreis xp,yp,xPol,yPol,xm2,ym2,r22,xb21,yb21,xb22,yb22,f%
  IF f%=1 THEN
    xb22=xb21:yb22=yb21:f%=0
  END IF
END IF
IF f% THEN RETURN
xm=xm3:ym=ym3:rq=r32
GOSUB PolpunktBerechnen
IF f% THEN
  xb31=xm3
  yb31=ym3
  xb32=xm3
  yb32=ym3
  f%=0
ELSE
  BestimmeSchnittpunktLinieKreis xp,yp,xPol,yPol,xm3,ym3,r32,xb31,yb31,xb32,yb32,f%
  IF f%=1 THEN
    xb32=xb31:yb32=yb31:f%=0
  END IF
END IF
IF f% THEN RETURN
IF Fa%=1 THEN
  SWAP xb11,xb12
  SWAP yb11,yb12
ELSEIF Fa%=2 THEN
  SWAP xb21,xb22
  SWAP yb21,yb22
ELSEIF Fa%=3 THEN
  SWAP xb31,xb32
  SWAP yb31,yb32
END IF
dy12=yb11-yb21:dy23=yb21-yb31:dy31=yb31-yb11
q=2#*(xb11*dy23+xb21*dy31+xb31*dy12)
IF q<>0# THEN
  h1=xb11*xb11+yb11*yb11
  h2=xb21*xb21+yb21*yb21
  h3=xb31*xb31+yb31*yb31
  mx(aL%)=(h1*dy23+h2*dy31+h3*dy12)/q
  my(aL%)=(h1*(xb31-xb21)+h2*(xb11-xb31)+h3*(xb21-xb11))/q
  dx=xb21-mx(aL%):dy=yb21-my(aL%)
  kr(aL%)=SQR(dx*dx+dy*dy)
  aL%=aL%+1
END IF
dy12=yb12-yb22:dy23=yb22-yb32:dy31=yb32-yb12
q=2#*(xb12*dy23+xb22*dy31+xb32*dy12)
IF q<>0# THEN
  h1=xb12*xb12+yb12*yb12
  h2=xb22*xb22+yb22*yb22
  h3=xb32*xb32+yb32*yb32
  mx(aL%)=(h1*dy23+h2*dy31+h3*dy12)/q
  my(aL%)=(h1*(xb32-xb22)+h2*(xb12-xb32)+h3*(xb22-xb12))/q
  dx=xb22-mx(aL%):dy=yb22-my(aL%)
  kr(aL%)=SQR(dx*dx+dy*dy)
  aL%=aL%+1
END IF
RETURN

PolpunktBerechnen:
dx=xa2-xa1:dy=ya2-ya1
h=(xm-xa1)*dy-(ym-ya1)*dx
f%=h=0#
IF NOT f% THEN
  aL=rq/h
  xPol=xm-aL*dy
  yPol=ym+aL*dx
END IF
RETURN

SUB BestimmeSchnittpunktLinieKreis (x1,y1,x2,y2,x,y,r2,xs1,ys1,xs2,ys2,f%) STATIC
  BestimmeLinieLotfusspunkt x1,y1,x2,y2,x,y,xl,yl
  dx=xl-x
  dy=yl-y
  a2=dx*dx+dy*dy
  f%=a2>r2
  IF ABS(r2-a2)<=2#*LTol*SQR(r2) THEN
    f%=1
    xs1=xl
    ys1=yl
  ELSEIF NOT f% THEN
    b=SQR(r2-a2)
    dx=x2-x1
    dy=y2-y1
    a2=dx*dx+dy*dy
    a=SQR(a2)
    xb=b*dx/a
    yb=b*dy/a
    xs1=xl+xb
    ys1=yl+yb
    xs2=xl-xb
    ys2=yl-yb
  END IF
END SUB

SUB BestimmeLinieLotfusspunkt(x1,y1,x2,y2,xp,yp,xl,yl) STATIC
  dx=x2-x1
  dy=y2-y1
  IF dx=0# THEN
    xl=x1
    yl=yp
  ELSEIF dy=0# THEN
    xl=xp
    yl=y1
  ELSE
    S=dy/dx
    p=-dx/dy
    xl=(y1-x1*S-yp+xp*p)/(p-S)
    yl=(x1+y1*p-xp-yp*S)/(p-S)
  END IF
END SUB
